"""v0

Revision ID: 32b70440e82f
Revises: 
Create Date: 2024-11-03 20:07:51.987295

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision: str = '32b70440e82f'
down_revision: Union[str, None] = None
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('py_tx_queue__jobs',
        sa.Column('id', sa.BIGINT(), autoincrement=True, nullable=False),
        sa.Column('external_id', sa.String(), nullable=True),
        sa.Column('queue', sa.String(), nullable=False),
        sa.Column('worker', sa.String(), nullable=False),
        sa.Column('data', postgresql.JSONB(astext_type=sa.Text()), nullable=False),
        sa.Column('status', postgresql.ENUM('INSERTED', 'EXECUTING', 'CANCELLED', 'SCHEDULED', 'RETRYABLE', 'DISCARDED', 'COMPLETED', name='jobstatus'), nullable=False),
        sa.Column('inserted_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=False),
        sa.Column('scheduled_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=False),
        sa.Column('attempted_at', sa.DateTime(timezone=True), nullable=True),
        sa.Column('cancelled_at', sa.DateTime(timezone=True), nullable=True),
        sa.Column('discarded_at', sa.DateTime(timezone=True), nullable=True),
        sa.Column('completed_at', sa.DateTime(timezone=True), nullable=True),
        sa.Column('elapsed_ms', sa.Integer(), nullable=True),
        sa.Column('errors', sa.String(), nullable=True),
        sa.Column('attempts', sa.Integer(), nullable=False),
        sa.Column('max_attempts', sa.Integer(), nullable=False),
        sa.Column('priority', sa.Integer(), nullable=False),
        sa.Column('tags', postgresql.ARRAY(sa.String()), nullable=True),
        sa.Column('meta', postgresql.JSONB(astext_type=sa.Text()), nullable=True),
        sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_py_tx_queue__jobs_external_id'), 'py_tx_queue__jobs', ['external_id'], unique=False)
    op.create_index(op.f('ix_py_tx_queue__jobs_queue'), 'py_tx_queue__jobs', ['queue'], unique=False)
    op.create_index(op.f('ix_py_tx_queue__jobs_status'), 'py_tx_queue__jobs', ['status'], unique=False)
    op.create_index(op.f('ix_py_tx_queue__jobs_worker'), 'py_tx_queue__jobs', ['worker'], unique=False)
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f('ix_py_tx_queue__jobs_worker'), table_name='py_tx_queue__jobs')
    op.drop_index(op.f('ix_py_tx_queue__jobs_status'), table_name='py_tx_queue__jobs')
    op.drop_index(op.f('ix_py_tx_queue__jobs_queue'), table_name='py_tx_queue__jobs')
    op.drop_index(op.f('ix_py_tx_queue__jobs_external_id'), table_name='py_tx_queue__jobs')
    op.drop_table('py_tx_queue__jobs')
    # ### end Alembic commands ###
